<?php
// Sécurité et récupération des données de configuration
define('OK',1);
include('debut.php'); // fournit $mysqli et $matieres

// Récupération des élèves
$resultat = $mysqli->query('SELECT id, CONCAT(nom,\' \',prenom) AS nom_complet, nom FROM utilisateurs WHERE autorisation = 2 ORDER BY nom_complet');
// Impossible d'aller plus loin si aucun élève existe
if ( !$resultat->num_rows )  {
  $p = "groupes";
  $t = 'Modification des groupes de colles';
  $message = 'Aucun élève n\'existe dans la base de données. Vous devez commencer par renseigner leur existence, soit vous-même via la page <a href="utilisateurs">Utilisateurs</a>, soit en leur disant de se connecter individuellement sur la partie publique (<em>Se connecter</em> puis <em>Créer un compte</em>).';
  include('haut.php');
  include('bas.php');
  exit();
}
$eid = array();
$select_eleves = <<<FIN
    <p id="ligneXX_YY" class="ligne"><label for="eleveXX_YY">Élève n°XX&nbsp;:</label>
      <select id="eleveXX_YY" name=eleves[]>
        <option value="0">[Choisir un élève]</option>

FIN;
while ( $r = $resultat->fetch_assoc() )  {
  $eid[$r['nom']] = $r['id'];
  $select_eleves .= "        <option value=\"${r['id']}\">${r['nom_complet']}</option>\n";
}
$resultat->free();
$select_eleves .=  "      </select>\n    </p>\n";

////////////////////////////////////
// Modifications des informations //
////////////////////////////////////
if ( isset($_REQUEST['id']) )  {
  // Connexion à la base de données
  $mysqli->close();
  $mysqli = mysql_ecriture();
  
  // Vérification que l'identifiant est valide. Défaut : id=0 (nouvelle information)
  if ( is_numeric($id = $_REQUEST['id']) && $id )  {
    $resultat = $mysqli->query("SELECT nom, eleves FROM groupes WHERE id = $id");
    if ( $resultat->num_rows )  {
      $r = $resultat->fetch_assoc();
      $resultat->free();
    }
    else
      $id = 0;
  }
  else
    $id = 0;

  // Traitement d'un ajout/modification
  if ( isset($_REQUEST['modifie']) )  {
    if ( !strlen($_REQUEST['nom']) )
      $message = 'Il n\'est pas possible de valider un nom de groupe vide. Pour supprimer un groupe, il faut cliquer sur Supprimer.';
    else  {
      // Validation des données envoyées
      $nom = $mysqli->real_escape_string($_REQUEST['nom']);
      $eleves = implode(',',array_intersect($eid,$_REQUEST['eleves']));
      $colle = ( isset($_REQUEST['colle']) ) ? 1 : 0;
      // Modification de $nom : on remplace tous les nombres par leur écriture
      // sur 6 chiffres, complété par des zéros à gauche.
      // Cf fonction zpad() dans docs.php
      $nom_nat = preg_replace_callback('/(\d+)/', function($m)  { return(str_pad($m[1],6,'0',STR_PAD_LEFT)); }, $nom);

      // Si $id > 0 : modification d'un groupe existant
      if ( $id )
        $message = ( requete('groupes',"UPDATE groupes SET nom = '$nom', nom_nat = '$nom_nat', colle = $colle, eleves = '$eleves' WHERE id = $id") ) ? "Le groupe $nom a bien été modifié." : "Le groupe $nom n'a pas pu être modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      // Sinon : ajout d'un nouveau groupe
      else
        $message = ( requete('groupes',"INSERT INTO groupes SET nom = '$nom', nom_nat = '$nom_nat', eleves = '$eleves'") ) ? "Le groupe $nom a bien été ajouté." : "Le groupe $nom n'a pas pu être ajouté. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';

      // Mise en ordre alphabétique naturel
      $mysqli->query('ALTER TABLE groupes ORDER BY nom_nat');
    }
  }

  // Suppression d'un groupe
  elseif ( $id && isset($_REQUEST['supprime']) )
    $message = ( requete('groupes',"DELETE FROM groupes WHERE id = $id") ) ? "Le groupe ${r['nom']} a bien été supprimé." : "Le groupe ${r['nom']} n'a pas pu être supprimé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';

  // Passage en connexion MySQL en lecture seulement
  $mysqli->close();
  $mysqli = mysql_lecture();
}

//////////
// HTML //
//////////
// Haut de page, menu et message
$p = "groupes";
$t = 'Modification des groupes d\'élèves';
include('haut.php');
?>

  <div class="item aide">
    <h3>Aide et explications</h3>
    <p>Vous pouvez ci-dessous ajouter et modifier des groupes d'élèves. Ces groupes sont utilisés à deux endroits&nbsp;:</p>
    <ul>
      <li>l'envoi de mails (professeurs et colleurs)</li>
      <li>la saisie de notes de colles (professeurs et colleurs)</li>
    </ul>
    <p>Les groupes d'élèves ne se limitent pas obligatoirement qu'aux groupes de colles&nbsp;: il peut être notamment intéressant de créer les deux demi-groupes de la classe ou les groupes de LV2 par exemple, pour envoyer des mails à la seule partie concernée de la classe.</p>
    <h4>Préférences associées à chaque groupe</h4>
    <p>Le <em>nom</em> est ce qui sera affiché lors de l'utilisation de ce groupe. Il peut s'agir d'un simple numéro (1,2,3...) pour des groupes de colles, d'une lettre ou d'un mot pour des demi-groupes par exemple (A et B, impairs et pairs...), ou encore d'un nom plus long (&laquo;&nbsp;LV2 Espagnol&nbsp;&raquo;).</p>
    <p>Si la case à cocher <em>Ce groupe est un groupe de colle</em> est cochée, le groupe apparaîtra à la page d'<a href="mail">Envoi de mails</a> et à la page de <a href="notes">saisie de notes</a>. Si elle n'est pas cochée, il n'apparaîtra qu'à la page d'<a href="mail">Envoi de mails</a>.</p>
    <p>Il est possible d'inscrire autant d'élève que souhaité dans chaque groupe. Le choix <em>[Choisir un élève]</em> ne correspond à aucun élève et ne compte donc pas (il n'y a pas de &laquo;&nbsp;case vide&nbsp;&raquo;). Les élèves sont automatiquement classés par ordre alphabétique au sein du groupe. Les doublons sont automatiquement éliminés.</p>
    <h4>Ordre des groupes</h4>
    <p>Les groupes sont automatiquement classés par ordre alphanumérique naturel&nbsp;: les nombres sont avant les mots, et les nombres sont comptés de façon globale (&laquo;&nbsp;2&nbsp;&raquo; est plus petit que &laquo;&nbsp;10&nbsp;&raquo;).</p>
  </div>

<?php

// Fonction d'affichage des infos
function affichage_groupe($r)  {
  if ( $id = $r['id'] )  {
    $eid = explode(',',$r['eleves']);
    if ( count($eid) > 5 )
      $titre = "Groupe ${r['nom']} (".count($eid).' élèves)';
    else
      $titre = "Groupe ${r['nom']} (". implode(', ',array_keys(array_intersect($GLOBALS['eid'],$eid))) .')';
    $valide1 = '';
    $valide = "\n      <input type=\"submit\" name=\"modifie\" value=\"Valider\" title=\"Valider les modifications sur ce groupe\">";
    $suppr = "\n      <input type=\"submit\" name=\"supprime\" value=\"Supprimer\" title=\"Supprimer ce groupe\">";
  }
  else  {
    $titre = 'Ajouter un nouveau groupe';
    $valide1 = "\n    <input class=\"bouton\" type=\"submit\" name=\"modifie\" value=\"Valider\" title=\"Valider les modifications\">";
    $valide = $suppr = '';
    $eid = array(0);
  }
  echo <<<FIN
  <div class="item admin">
  <form action="" method="post">$valide1
    <h3>$titre</h3>
    <p class="boutons">$valide$suppr
    </p>
    <p class="ligne"><label for="nom$id">Nom du groupe&nbsp;: </label><input type="text" id="nom$id" name="nom" value="${r['nom']}" size="50"></p>
    <p class="ligne"><label for="colle$id">Ce groupe est un groupe de colle&nbsp;: </label><input type="checkbox" id="colle$id" name="colle" value="1"${r['colle']}></p>

FIN;
  $n = 0;
  foreach ( $eid as $e )
    echo str_replace(array("\"$e\"",'XX','YY'),array("\"$e\" selected",++$n,$id),$GLOBALS['select_eleves']);
  echo <<<FIN
    <p class="boutons">
      <input type="button" class="ajouter" value="Ajouter un élève">
      <input type="hidden" name="n" value="$n">
      <input type="button" class="retirer" value="Retirer le dernier élève">
    </p>
    <input type="hidden" name="id" value="$id">
  </form>
  </div>


FIN;
}

// Formulaire de nouveau groupe
affichage_groupe(array('id' => 0, 'nom' => '', 'colle' => ' checked'));

// Formulaires de modification des groupes
$resultat = $mysqli->query('SELECT id, nom, IF(colle,\' checked\',\'\') AS colle, eleves FROM groupes');
if ( $resultat->num_rows )  {
  while ( $r = $resultat->fetch_assoc() )
    affichage_groupe($r);
  $resultat->free();
}
else
  echo "  <h2>Il n'y a actuellement aucun groupe d'élèves défini.</h2>\n\n";

$mysqli->close();

?>

  <script type="text/javascript">
$( function() {
  var select = '<?php echo str_replace(array("'","\n",'  '),array("\'",'',''),$select_eleves); ?>';
  $('.ajouter').click(function () {
    id = $(this).parent().next().val();
    n = $(this).next().val();
    $(this).next().val(++n);
    $( select.replace(/XX/g,n).replace(/YY/g,id) ).insertBefore($(this).parent());
  });
  $('.retirer').click(function () {
    id = $(this).parent().next().val();
    n = $(this).prev().val();
    if ( n > 1 )  {
      $('#ligne'+n+'_'+id).remove();
      $(this).prev().val(--n);
    }
  });

});
  </script>

<?php
// Bas de page
include('bas.php');
?>
