<?php
// Sécurité et récupération des données de configuration
define('OK',1);
include('debut.php');

$p = 'prefs';
$t = 'Cahier de Prépa - Mon compte';
$mysqli = premiere_connexion();
// Vérification que l'on est bien connecté
if ( $autorisation < 1 )
  include('login.php');
// Modification impossible pour les comptes invités
if ( $autorisation == 1 )  {
  $message = 'Il est impossible de modifier les préférences de ce compte.';
  include('haut.php');
  include('bas.php');
  exit();
}

// Récupération des données de l'utilisateur
$resultat = $mysqli->query("SELECT login, nom, prenom, genre, mail, mdp, matieres, timeout, mailexp, mailcopy
                            FROM utilisateurs WHERE id = ${_SESSION['id']}");
$u = $resultat->fetch_assoc();
$resultat->free();

///////////////////
// Modifications //
///////////////////
if ( isset($_REQUEST['modifie']) )  {

  // Vérification du mot de passe
  if ( ( sha1($_REQUEST['mdp0']) != $u['mdp'] ) && ( $u['mdp'] != 'pas de mot de passe' ) )
    $message = 'Le mot de passe fourni est incorrect. Les modifications n\'ont pas été effectuées.';
  else  {

    // Fonctions de connexion/enregistrement
    include('admin/fonctions.php');

    $requete = array();
    $modif = array();
    // Validation des données envoyées
    $login = strip_tags($mysqli->real_escape_string($_REQUEST['login']));
    $prenom = mb_convert_case(strip_tags($mysqli->real_escape_string($_REQUEST['prenom'])),MB_CASE_TITLE,'UTF-8');
    $nom = mb_convert_case(strip_tags($mysqli->real_escape_string($_REQUEST['nom'])),MB_CASE_TITLE,'UTF-8');
    $mail = strtolower($mysqli->real_escape_string($_REQUEST['mail']));
    if ( in_array($genre = $_REQUEST['genre'],array(1,2,3)) && ( $genre != $u['genre'] ) )  {
      $u['genre'] = $genre;
      $requete[] = "genre = $genre";
      $modif[] = 'genre';
    }
    if ( strlen($login) && ( stripslashes($login) != $u['login'] ) )  {
      // Vérification que le login n'existe pas déjà
      $resultat = $mysqli->query("SELECT id FROM utilisateurs WHERE login = '$login'");
      if ( $resultat->num_rows )
        $resultat->free();
      else  {
        $u['login'] = stripslashes($login);
        $requete[] = "login = '$login'";
        $modif[] = 'identifiant';
        $_SESSION['login'] = stripslashes($login);
      }
    }
    if ( strlen($nom) && ( stripslashes($nom) != $u['nom'] ) )  {
      $u['nom'] = stripslashes($nom);
      $requete[] = "nom = '$nom'";
      $modif[] = 'nom';
    }
    if ( strlen($prenom) && ( stripslashes($prenom) != $u['prenom'] ) )  {
      $u['prenom'] = stripslashes($prenom);
      $requete[] = "prenom = '$prenom'";
      $modif[] = 'prénom';
    }
    if ( ( $mail != $u['mail'] ) && ( filter_var($mail,FILTER_VALIDATE_EMAIL) || !strlen($mail) ) )  {
      $u['mail'] = $mail;
      $requete[] = "mail = '$mail'";
      $modif[] = 'mail';
    }
    if ( strlen($mdp1 = $_REQUEST['mdp1']) && ( $mdp1 == $_REQUEST['mdp2'] ) && ( ( $mdp1 = sha1($mdp1) ) != $u['mdp'] ) )  {
      $u['mdp'] = $mdp1;
      $requete[] = "mdp = '$mdp1'";
      $modif[] = 'mot de passe';
    }
    if ( is_numeric( $timeout = $_REQUEST['timeout'] ) && ( $timeout != $u['timeout'] ) )  {
      if ( $timeout < 60 )
        $timeout = 60;
      $u['timeout'] = $timeout;
      $requete[] = "timeout = $timeout";
      $modif[] = 'temps de connexion';
      $_SESSION['timeout'] = $timeout;
    }
    // Modification de mailexp et mailcopy uniquement si mailexp est non nul
    if ( $u['mailexp'] && in_array($mailexp = $_REQUEST['mailexp'],array(1,2,3,4)) && ( $mailexp != $u['mailexp'] ) )  {
      $u['mailexp'] = $mailexp;
      $requete[] = "mailexp = $mailexp";
      $modif[] = 'champ expéditeur des mails';
    }
    $mailcopy = ( isset($_REQUEST['mailcopy']) ) ? 1 : 0;
    if ( $u['mailexp'] && ( $mailcopy != $u['mailcopy'] ) )  {
      $u['mailcopy'] = $mailcopy;
      $requete[] = "mailcopy = '$mailcopy'";
      $modif[] = 'mise en copie des mails';
    }
    $m = ( isset($_REQUEST['matieres']) ) ? array_filter(array_unique($_REQUEST['matieres'],SORT_NUMERIC),'is_numeric') : array();
    if ( ( $m = implode(',',$m) ) != $u['matieres'] )  {
      $requete[] = "matieres = '$m'";
      $modif[] = 'matières';
      $_SESSION['matieres'] = $m;
    }
        
    if ( !empty($requete) )  {
      $requete = implode(', ',$requete);
      $modif = implode(', ',$modif);
      // Connexion à la base de données avec les droits d'écriture
      $mysqli->close();
      $mysqli = mysql_ecriture();
      if ( requete('utilisateurs',"UPDATE utilisateurs SET $requete WHERE id = ${_SESSION['id']}") )
        $message = "Les modifications ($modif) ont bien été réalisées.";
    }
  }
}

//////////////
//// HTML ////
//////////////

// Plus de mot de passe : remise à zéro suite à une demande de mot de passe oublié
if ( $u['mdp'] == 'pas de mot de passe' )  {
  $message = 'IMPORTANT : votre mot de passe a été réinitialisé. Vous devez absolument le redéfinir ci-dessous.';
  $mdp0 = '    <input type="hidden" name="mdp0" value="réinitialisé">';
  $mdp_message = '';
}
else  {
  $mdp0 = '    <p class="ligne"><label for="mdp0">Mot de passe actuel&nbsp;: </label><input type="password" id="mdp0" name="mdp0" value=""></p>';
  $mdp_message = '    <p>Le mot de passe actuel doit être obligatoirement fourni.</p>';
}

// Haut de page, menu et message
include('haut.php');

// Pas de gestion des préférences de mail si mailexp est nul
if ( $u['mailexp'] )  {
  if ( strlen($u['mail']) )  {
    switch ( $u['genre'] )  {
      case 1 : $g = 'M. '; break;
      case 2 : $g = 'Mme '; break;
      case 3 : $g = 'Melle '; break;
      default : $g = '';
    }
    $select_mailexp = str_replace("\"${u['mailexp']}\"","\"${u['mailexp']}\" selected","
          <option value=\"1\">$g${u['nom']}</option>
          <option value=\"2\">$g${u['prenom']} ${u['nom']}</option>
          <option value=\"3\">${u['prenom']} ${u['nom']}</option>
          <option value=\"4\">${u['nom']}</option>");
  }
  else
    $select_mailexp = '
          <option value="1">Il faut définir votre adresse mail pour pouvoir en envoyer.</option>';
  $u['mailcopy'] = ( $u['mailcopy']) ? ' checked' : '';
  $prefs_mail = <<<FIN
    <p class="ligne"><label for="mailexp">Champ expéditeur pour les mails&nbsp;:</label>
      <select name="mailexp" id="mailexp">$select_mailexp
      </select>
    </p>
    <p class="ligne"><label for="mailcopy">Étre en copie des mails envoyés&nbsp;: </label><input type="checkbox" id="mailcopy" name="mailcopy" value="1"${u['mailcopy']}></p>

FIN;
}
else  {
  $prefs_mail = '';
}

// Formulaire des données
$select_genre = str_replace("\"${u['genre']}\"","\"${u['genre']}\" selected",'
        <option value="1">M.</option>
        <option value="2">Mme</option>
        <option value="3">Melle</option>');
echo <<<FIN
  <div class="item admin">
  <form action="" method="post">
    <input class="bouton" type="submit" name="modifie" value="Valider" title="Valider les modifications">
    <h3>Modifier mon compte</h3>
    <p class="ligne"><label for="genre">M-Mme-Melle&nbsp;:</label>
      <select name="genre" id="genre">$select_genre
      </select>
    </p>
    <p class="ligne"><label for="login">Identifiant&nbsp;: </label><input type="text" id="login" name="login" value="${u['login']}" size="50"></p>
    <p class="ligne"><label for="prenom">Prénom&nbsp;: </label><input type="text" id="prenom" name="prenom" value="${u['prenom']}" size="50"></p>
    <p class="ligne"><label for="nom">Nom&nbsp;: </label><input type="text" id="nom" name="nom" value="${u['nom']}" size="50"></p>
    <p class="ligne"><label for="mail">Adresse mail&nbsp;: </label><input type="text" id="mail" name="mail" value="${u['mail']}" size="50"></p>
$mdp0
    <p class="ligne"><label for="mdp1">Nouveau mot de passe&nbsp;: </label><input type="password" id="mdp1" name="mdp1" value=""></p>
    <p class="ligne"><label for="mdp2">Confirmation&nbsp;: </label><input type="password" id="mdp2" name="mdp2" value=""></p>
    <p class="ligne"><label for="timeout">Temps de déconnexion&nbsp;: </label><input type="text" id="timeout" name="timeout" value="${u['timeout']}" size="3"></p>
$prefs_mail
    <h3>Modifier mes matières</h3>

FIN;

// Modification des matières
$resultat = $mysqli->query("SELECT id, cle, nom FROM matieres WHERE FIND_IN_SET(id,'${_SESSION['matieres']}')
                            ORDER BY FIND_IN_SET(id,'${_SESSION['matieres']}')");
$matieres = array();
if ( $resultat->num_rows )  {
  while ( $r = $resultat->fetch_assoc() )
    $matieres[] = $r;
  $resultat->free();
}
$resultat = $mysqli->query("SELECT id, nom, ordre FROM matieres ORDER BY ordre");
$select = "    <p id=\"ligneXX\" class=\"ligne\"><label for=\"matiereXX\">Matière n°XX&nbsp;:</label>\n      <select id=\"matiereXX\" name=matieres[XX]>\n";
$max = $resultat->num_rows;
while ( $r = $resultat->fetch_assoc() )
  $select .= "        <option value=\"${r['id']}\">${r['nom']}</option>\n";
$resultat->free();
$select .= "      </select>\n    </p>\n";
$mysqli->close();

$n = 0;
foreach ( $matieres as $m )
  echo str_replace("\"${m['id']}\"","\"${m['id']}\" selected",str_replace('XX',++$n,$select));
$select = str_replace(array("'","\n",'  '),array("\'",'',''),$select);

echo <<<FIN
    <p class="boutons">
      <input type="button" id="ajouter" value="Ajouter une matière">
      <input type="button" id="retirer" value="Retirer la dernière matière">
    </p>
  </form>
$mdp_message
  </div>

  <script type="text/javascript">
\$( function() {
  var n = $n;
  var select = '$select';
  \$('#ajouter').click(function () {
    if ( n < $max )  {
      n++;
      \$( select.replace(/XX/g,n) ).insertBefore(\$(this).parent());
    }
  });
  \$('#retirer').click(function () {
    if ( n )  {
      \$('#ligne'+n).remove();
      n--;
    }
  });

});
  </script>


FIN;

// Bas de page
include('bas.php');
?>
